package com.izouma.dingdong.web.user;

import com.izouma.dingdong.converter.StringArrayConverter;
import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.user.UserCoupon;
import com.izouma.dingdong.service.user.UserCouponService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.user.UserCouponRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/userCoupon")
@AllArgsConstructor
public class UserCouponController extends BaseController {
    private UserCouponService userCouponService;
    private UserCouponRepo userCouponRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public UserCoupon save(@RequestBody UserCoupon record) {
        if (record.getId() != null) {
            UserCoupon orig = userCouponRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return userCouponRepo.save(orig);
        }
        return userCouponRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<UserCoupon> all(PageQuery pageQuery) {
        return userCouponRepo.findAll(toSpecification(pageQuery, UserCoupon.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public UserCoupon get(@PathVariable Long id) {
        return userCouponRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        userCouponRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<UserCoupon> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @ApiOperation("后台发放优惠券")
    @PostMapping("/issue")
    public void issue(@RequestParam Long userId, String couponId) {
        //转换
        StringArrayConverter converter = new StringArrayConverter();
        List<String> strings = converter.convertToEntityAttribute(couponId);
        strings.forEach(id->{
            UserCoupon build = UserCoupon.builder()
                    .couponId(Long.parseLong(id))
                    .isUsed(false)
                    .userId(userId)
                    .build();
            userCouponRepo.save(build);
        });
    }
}

